// Program: Lesson 28 - Excercise 3

#include <iostream.h>

class complex
{
 public:
	complex(float real=0, float imaginary=0) { re = real;
						   im = imaginary; }
	complex& operator=(const complex& c)     { re = c.re; im = c.im;
						   return *this; }

	friend complex operator+(complex& c, float f);
	friend complex operator+(float f, complex& c);
	friend ostream& operator<<(ostream& o, complex& c); // added

 private:
	float re, im;
 };

complex operator+(complex& c, float f)
 {
	complex result = c;
	result.re += f;
	return result;
 }

complex operator+(float f, complex& c)
 {
	return c+f;
 }

ostream& operator<<(ostream& o, complex& c) // added
 {
	o << c.re << "+" << c.im << "i";
	return o;
 }

void main(void)
 {
	float f=3;
	complex c(1,2), result;
	result=f+c;
	cout << result << endl; // added
	result=c+f;
	cout << result << endl; // added
 }