// Program: Lesson 28 - Excercise 4

#include <iostream.h>
#include <string.h>

class book;
class borrowed_book;

// --- class librarian ------------------------------------------
class librarian {
 public:
   void change_catalog(book *, char *);
	char *get_catalog(book);
	void borrow_book(borrowed_book* book, char* borrower);
	void return_book(borrowed_book* book);
};
// --- class book -----------------------------------------------
class book {
 public:
   book(char *, char *, char *);
   void show_book(void);
	friend char *librarian::get_catalog(book);
	friend void librarian::change_catalog(book *, char *);
 private:
   char title[64];
   char author[64];
   char catalog[64];
};
// --- class borrowed_book ------------------------------------------
class borrowed_book : public book
 {
	public:
			borrowed_book(char* title, char* author, char* catalog, char* newborrower)
					: book (title, author, catalog)
				{
					strcpy (borrower,newborrower);
				}

		friend void librarian::borrow_book(borrowed_book* book, char* borrower);
		friend void librarian::return_book(borrowed_book* book);

	private:
		char borrower[80];
 };

// --- book function ------------------------------------------------
book::book(char *title, char *author, char *catalog)
 {
   strcpy(book::title, title);   
   strcpy(book::author, author);
   strcpy(book::catalog, catalog);
 }

void book::show_book(void)
 {
   cout << "Title: " << title << endl;
   cout << "Author: " << author << endl;
   cout << "Catalog: " << catalog << endl;
 }
// --- librarian function ------------------------------------------
void librarian::change_catalog(book *this_book, char *new_catalog)
{
	strcpy(this_book->catalog, new_catalog);
}
char *librarian::get_catalog(book this_book)
{
   static char catalog[64];

   strcpy(catalog, this_book.catalog);
   return(catalog);
}
void librarian::borrow_book(borrowed_book* book, char* borrower)
{
	strcpy(book->borrower, borrower);
}
void librarian::return_book(borrowed_book* book)
{
	strcpy(book->borrower, "CHECKED-IN");
}
// --- main function ---------------------------------------------
void main(void)
 {
   book programming("Rescued By C++", "Jamsa", "P101");
   librarian library;

   programming.show_book();

   library.change_catalog(&programming, "EASY C+ 101");

   programming.show_book();
 }


