// Program: Lesson 32 - Excercise 3

#include <iostream.h>
#include <stdlib.h>
//#include <new.h>
#include <alloc.h>

class fast {
	char data[34];
};

fast alloc_buffer[50];
int  alloc_used[50];

static void *operator new(size_t size)
 {
	// check if this is a fast object
	if (size != sizeof(fast))
	  return ::malloc(size);

	for (int i = 0 ; i < 50; i++)
	   if (alloc_used[i] == 0)
		{
			alloc_used[i] = 1;
			return (void*)&alloc_buffer[i];
		}
	// if preallocated buffer is entirely consumed, use malloc anyway
	return ::malloc(size);
}

static void operator delete(void* ptr)
 {
	for (int i = 0; i < 50; i++)
	   if (ptr == (void*) &alloc_buffer[i])
	    {
	      alloc_used[i] = 0;
	      return;
	    }
	free(ptr);
 }

void main(void)
{
	fast *p = new fast[20];

	delete p;
}
