// Program: Lesson 34 - Excercise 2

#include <iostream.h>
#include <fstream.h>
#include <string.h>

class person {
 public:
	person(char* first, char* last, int person_age);
	void write(ofstream& f);
	void read(ifstream& f);
	void print(void);

 private:
	char firstname[80];
	char lastname[80];
	int age;
};


person::person(char* first, char* last, int person_age)
 {
	strcpy(firstname, first);
	strcpy(lastname, last);
	age = person_age;
 }

void person::print(void)
 {
    cout << firstname << " " << lastname << " is " << age
	 << " years old" << endl;
 }

void person::write(ofstream& f)
 {
	f.write(firstname, 80);
	f.write(lastname, 80);
	f.write((char*)&age, sizeof(int));
 }

void person::read(ifstream& f)
{
	f.read(firstname, 80);
	f.read(lastname, 80);
	f.read((char*)&age, sizeof(int));
}


void main(void)
 {
    ofstream fout("test.dat");
    person p1("joe", "jones", 36);
    person p2("moe", "mones", 27);
    p1.write(fout);
    p2.write(fout);

    ifstream fin("test.dat");
    p1.read(fin);
    p1.print();
    p2.read(fin);
    p2.print();
 }
