#include <iostream.h>
#include <string.h>
#include "ex30_2.h"

template <class T>
void list<T>::add(T *new_block)
  {
	 if (head==NULL)
		head = last = new_block;
	 else
		last->add(new_block);

	last=new_block;
  }
template <class T>
void list<T>::print(void)
  {
	 T *tmp;
	 for(tmp=head; tmp!=NULL; tmp=tmp->next)
		tmp->show();
	 cout << endl;
  }
template <class T>
void list<T>::delete_object(int object_number)
  {
	 T *tmp, *del;
	 int i;
	 for(tmp=head, i = 1; tmp!=NULL && i != object_number - 1; tmp=tmp->next, i++);
	 del = tmp;
	 delete del->next;
	 tmp->next = tmp->next->next;
  }
template <class T>
list<T>::~list(void)
  {
	 T *tmp = head, *last = head->next;
	 while ( tmp )
	 {
		delete tmp;
		tmp = last;
		last = last->next;
	 }
	 cout << "free list ok" << endl;
  }

void main(void)
  {
	 number<float> *n;
	 number<int> *in;
	 list <number<float>,> list_float_number;
	 list <number<int>,> list_int_number;
	 float f;
	 int num;

	 cout<<"Enter a float number 3 times\n";
	 for(int i=0; i<3; i++)
	 {
			cin>>f;
			n=new number<float>(f);
			list_float_number.add(n);
	 }
	 list_float_number.print();
	 list_float_number.delete_object(2);
	 list_float_number.print();
	 cout<<endl;
	 cout<<"Enter a int number 3 times\n";
	 for(i=0; i<3; i++)
	 {
			cin>>num;
			in=new number<int>(num);
			list_int_number.add(in);
	 }
	 list_int_number.print();
	 cout<<endl;
  }
