#include <iostream.h>
#include <string.h>

class employee {
 public:
   employee(char *, long, float);
   ~employee(void);
   void show_employee(void);
   int change_salary(float);
   long get_id(void);
 private:
   char name[64];
   long employee_id;
   float salary;
};

employee::employee(char *name, long employee_id, 
  float salary)
 {
   strcpy(employee::name, name);
   employee::employee_id = employee_id;
   if (salary < 50000.0)
     employee::salary = salary;
   else
     employee::salary = 0.0;  // Invalid salary specified
 }

employee::~employee(void)
 {
   cout << "Destroying the object for " << name << endl;
 }

void employee::show_employee(void)
 { 
   cout << "Employee: " << name << endl;
   cout << "Id: " << employee_id << endl;
   cout << "Salary: " << salary << endl;
 }

void main(void)
 {
   employee worker("Happy Jamsa", 101, 10101.0);

   worker.show_employee();
 }

