#include <iostream.h>
#include <stdlib.h>

class arrayC
	{
		float *fp;
		int size;
		public:
			arrayC(int number_of_elements);
			float &operator[](int index) const;
			~arrayC();
	};

arrayC::arrayC(int number_of_elements)
	{
		if ((fp = new float[number_of_elements])!=NULL)
			size = number_of_elements;
		else
			size = 0;
	}


float &arrayC::operator[](int index) const
	{
		if(index >= 0 && index< size)
			return(fp[index]);
		else
			{
				cout<<"index is out of range\n";
				exit(1);
			}
	}

arrayC::~arrayC()
	{
		if ( fp ) delete fp;
	}

void main(void)
	{
		arrayC  fa(4);

		fa[1] = 12.86f;
		cout << "fa[1]=" << fa[1] << endl;
		fa[3] = fa[1] + 3.21f;
		cout << " fa[3] = fa[1] + 3.21f ="  << fa[3] << endl;
	}
