#include <iostream.h>
#include <string.h>

class errbase
	{
		public:
			virtual void print() {cout<<"errbase"<<endl;}
	};
class errname: public errbase
	{
		public:
			void print(){cout<<"errname - long name"<<endl;}
	};
class errquant: public errbase
	{
		public:
			void print(){cout<<"errquant"<<endl;}
	};

class errquant1: public errquant
	{
		public:
			void print(){cout<<"errquant1 > 5000"<<endl;}
	};

class errquant2: public errquant
	{
	public:
			void print(){cout<<"errquant2 < 0"<<endl;}
	};

class errprice: public errbase
	{
	public:
			void print(){cout<<"errprice"<<endl;}
	};

class errprice1: public errprice
	{
		public:
			void print(){cout<<"errprice1 > 500"<<endl;}
	};

class errprice2: public errprice
	{
		public:
			void print(){cout<<"errprice2 < 0"<<endl;}
	};

class product
{
	private:	
		char name[15];
		long quant;
		double price;
	public:
		void get(char *nm, long qu, double pr)
			{
				if (strlen(nm) > 14)
					throw errname();
				else
					strcpy (name, nm);
				if (qu > 50000)
					throw errquant1();
				else
					if (qu < 0)
						throw errquant2();
					else
						quant = qu;
				if (pr > 500)
					throw errprice();
				else
					if (pr < 0)
						throw errprice2();
					else
						price = pr;
			}
		void show()
			{
				cout<<"name = "<<name<<" quant= " <<quant<<" price= " <<price<<endl;
			}	
	};

void main(void)
	{
		product p[6];
		char *nm[6] = {"cellular", "computer","screen","sea food", "name_name_and_more_name","book"};
		long qu[6] = {72100L, 37L, 90L, -3L, 230L, 69L};
		double pr[6] = {46.25f, -7.80f, 9.25f, 3.12f, 887.39f, 1.15f};

		for (int i = 0; i < 6; i++)
			{
				try
					{
						cout<<endl;
						cout<<"input products"<<endl;
						cout<<nm[i]<<"   "<<qu[i]<<"     "<<pr[i]<<endl;
						p[i].get(nm[i], qu[i], pr[i]);
						p[i].show();
					}
				catch(errbase& msg)
					{
						msg.print();
					}
			}
	}
